(function($){
    Total = function(millisecondes, divID){
        this.eventName = "totalEvent.Total";
        this.number = 0;
        this.source = "";
        this.total = 0;
        this.timeStamp = 0;
        this.output = new Table();
        this.pair = new Pair();
        this.impair = new Impair();
        
        this.init(millisecondes, divID);
    }
    
    Total.prototype = {
        init:function(milliseconds, divID){
            var t = milliseconds || 1000;				
            var self = this; // bonne pratique car jQuery peut modifier this
            
            $(this).bind(self.eventName, self.totalEventHandler);
            
            // window.setInterval et window.setTimeout modifient this
            
            var pairInterval  = window.setInterval(function(){
                self.pair.add(self);
            }, 30);
            
            var impairInterval = window.setInterval(function(){
                self.impair.add(self);
            }, 40);
            
            window.setTimeout(function(){
                window.clearInterval(pairInterval);
                window.clearInterval(impairInterval);
                self.output.print(divID);
            }, t);
            
        },
        totalEventHandler:function(event){
            if ((event.dvjh != null) && (event.dvjh != undefined) && (event.dvjh.length == 1)){
                this.number = event.dvjh.p1Data;
                this.source = event.dvjh.p1Name;
                
                this.total += this.number;
                this.timeStamp = event.timeStamp;
                
                if ((this.output != null) && (this.output != undefined) && 
                        (this.output.eventName != null) && (this.output.eventName != undefined)){
                        
                    var self = this; // bonne pratique car jQuery peut modifier this
                    
                    var outputEvent = new $.Event(self.output.eventName);
                    
                    // on adopte la convention suivante :
                    // event.dvjh.length donne le nombre de params : p1, p2, etc
                    // event.dvjh.p1Name donne le(s) libell(s) du param p1
                    // event.dvjh.p1Data contient la/les donne(s) du param p1.
                    outputEvent.dvjh = {
                        length:1,
                        p1Name:new Array("Total", "Nombre", "Source", "TimeStamp ms"),
                        p1Data:new Array(this.total, this.number, this.source, this.timeStamp)
                    };
                    
                    $(this.output).trigger(outputEvent);
                }
            }
            
            return false;
        }
    };
})(jQuery);